package dev.fyloz.colorrecipesexplorer.model.account

import dev.fyloz.colorrecipesexplorer.model.ModelEntity
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import javax.persistence.*

@Entity
@Table(name = "user_group")
data class Group(
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  override val id: Long,

  @Column(unique = true)
  val name: String,

  @Enumerated(EnumType.STRING)
  @ElementCollection(fetch = FetchType.EAGER)
  @CollectionTable(name = "group_permission", joinColumns = [JoinColumn(name = "group_id")])
  @Column(name = "permission")
  @Fetch(FetchMode.SUBSELECT)
  val permissions: List<Permission>,
) : ModelEntity